# $Revision: 1.24.2.16 $, $Date: 2007/10/15 08:26:44 $
#
# Conditional build:
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace programs
%bcond_without	dist_kernel	# without distribution kernel
%bcond_without	up		# don't build UP module
%bcond_without	smp		# don't build SMP module
%bcond_with	verbose		# verbose build (V=1)
%bcond_without	vserver		# build with vserver patches
%bcond_with	grsec_kernel	# build for kernel-grsecurity
#
%if %{without kernel}
%undefine	with_dist_kernel
%endif
#
%if %{with kernel} && %{with dist_kernel} && %{with grsec_kernel}
%define	alt_kernel	grsecurity
%endif
#
%ifarch sparc
%undefine	with_smp
%endif

#define		_snap	20060916-2203
%define		_rel	55
#
Summary:	A Stackable Unification File System
Summary(pl):	Stakowalny, unifikujcy system plikw
Name:		unionfs
Version:	1.2
Release:	%{?_snap:0.%(echo %{_snap} | tr - _).}%{_rel}
License:	GPL v2
Group:		Base/Kernel
#Source0:	ftp://ftp.fsl.cs.sunysb.edu/pub/unionfs/snapshots/%{name}-%{_snap}.tar.gz
Source0:	ftp://ftp.fsl.cs.sunysb.edu/pub/unionfs/%{name}-%{version}.tar.gz
# Source0-md5:	2a8c6ef320efc43af91074ab47046f09
Patch0:		%{name}-build.patch
Patch1:		%{name}-vserver.patch
URL:		http://www.filesystems.org/project-unionfs.html
%if %{with kernel}
%if %{with dist_kernel}
BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.16
BuildRequires:	kernel%{_alt_kernel}-module-build < 3:2.6.17
BuildRequires:	rpmbuild(macros) >= 1.326
%endif
BuildRequires:	libuuid-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Unionfs is a stackable unification file system, which can appear to
merge the contents of several directories (branches), while keeping
their physical content separate. Unionfs is useful for unified source
tree management, merged contents of split CD-ROM, merged separate
software package directories, data grids, and more. Unionfs allows any
mix of read-only and read-write branches, as well as insertion and
deletion of branches anywhere in the fan-out.

%description -l pl
Unionfs to stakowalny, unifikujcy system plikw, potraficy czy
zawarto kilku katalogw (gazi), zachowujc oddzielnie ich fizyczn
zawarto. Unionfs jest przydatny do zarzdzania poczonym drzewem
rde, poczon zawartoci podzielonych CD-ROM-w, poczonymi
oddzielnymi katalogami z pakietami programw, tabelami danych itp.
Unionfs pozwala na dowolne mieszanie gazi tylko do odczytu oraz do
odczytu i zapisu, a take wstawianie i usuwanie gazi w dowolnym
miejscu.

%package -n kernel%{_alt_kernel}-fs-unionfs
Summary:	Linux driver for unionfs
Summary(pl):	Sterownik Linuksa dla unionfs
Release:	%{_rel}@%{_kernel_ver_str}
Group:		Base/Kernel
Requires(post,postun):	/sbin/depmod
%if %{with dist_kernel}
%requires_releq_kernel_up
Requires(postun):	%releq_kernel_up
%endif

%description -n kernel%{_alt_kernel}-fs-unionfs
Linux driver for unionfs.

%description -n kernel%{_alt_kernel}-fs-unionfs -l pl
Sterownik Linuksa dla unionfs.

%package -n kernel%{_alt_kernel}-smp-fs-unionfs
Summary:	Linux SMP driver for unionfs
Summary(pl):	Sterownik Linuksa SMP dla unionfs
Release:	%{_rel}@%{_kernel_ver_str}
Group:		Base/Kernel
%if %{with dist_kernel}
%requires_releq_kernel_smp
Requires(postun):	%releq_kernel_smp
%endif
Provides:	kernel%{_alt_kernel}-unionfs = %{version}-%{_rel}@%{_kernel_ver_str}

%description -n kernel%{_alt_kernel}-smp-fs-unionfs
Linux SMP driver unionfs.

%description -n kernel%{_alt_kernel}-smp-fs-unionfs -l pl
Sterownik Linuksa SMP dla unionfs.

%prep
%setup -q %{?_snap:-n %{name}-%{_snap}}
%patch0 -p1
%{?with_vserver:%patch1 -p1}

%build
%if %{with kernel}
%build_kernel_modules -m unionfs \
	EXTRACFLAGS="-DUNIONFS_NDEBUG -DUNIONFS_XATTR"
%endif

%if %{with userspace}
%{__make} utils \
	CC="%{__cc}" \
	UNIONFS_OPT_CFLAG="%{rpmcflags} %{rpmldflags}"
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with kernel}
%install_kernel_modules -m unionfs -d kernel/fs
%endif

%if %{with userspace}
%{__make} install-utils \
	PREFIX=$RPM_BUILD_ROOT%{_prefix} \
	MANDIR=$RPM_BUILD_ROOT%{_mandir}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n kernel%{_alt_kernel}-fs-unionfs
%depmod %{_kernel_ver}

%postun -n kernel%{_alt_kernel}-fs-unionfs
%depmod %{_kernel_ver}

%post -n kernel%{_alt_kernel}-smp-fs-unionfs
%depmod %{_kernel_ver}smp

%postun -n kernel%{_alt_kernel}-smp-fs-unionfs
%depmod %{_kernel_ver}smp

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc AUTHORS NEWS INSTALL README
%attr(755,root,root) %{_sbindir}/*
%{_mandir}/man?/*
%endif

%if %{with kernel}
%if %{with up} || %{without dist_kernel}
%files -n kernel%{_alt_kernel}-fs-unionfs
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/kernel/fs/*.ko*
%endif

%if %{with smp} && %{with dist_kernel}
%files -n kernel%{_alt_kernel}-smp-fs-unionfs
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}smp/kernel/fs/*.ko*
%endif
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: unionfs.spec,v $
Revision 1.24.2.16  2007/10/15 08:26:44  glen
- rel 55 (kernel 2.6.16.55)

Revision 1.24.2.15  2007/10/15 08:21:38  glen
- rel drbd.spec (2.6.16.55)

Revision 1.24.2.14  2007/10/01 21:25:45  glen
- rel 54

Revision 1.24.2.13  2007/09/30 22:17:50  adamg
- release 53.1 (rebuild against 2.6.16.53-2)

Revision 1.24.2.12  2007/09/05 19:30:12  glen
- rel 53 (kernel 2.6.16.53)

Revision 1.24.2.11  2007/06/04 08:09:08  glen
- rel 52 (2.6.16.52)

Revision 1.24.2.10  2007/05/11 06:38:50  glen
- rel 51 (2.6.16.51)

Revision 1.24.2.9  2007/05/08 12:10:09  glen
- rel 50 (kernel 2.6.16.50)

Revision 1.24.2.8  2007/04/25 22:11:38  glen
- rel 6 (kernel 2.6.16.49)

Revision 1.24.2.7  2007/03/27 22:17:58  glen
- rel 5 (kernel 2.6.16.45)

Revision 1.24.2.6  2007/03/15 23:29:44  glen
- rel 4

Revision 1.24.2.5  2007/01/23 10:27:09  hawk
- release 3

Revision 1.24.2.4  2006/12/08 13:22:06  hawk
- workaround for builder automation to allow building against
  kernel-grsecurity (via bcond)
- release 2

Revision 1.24.2.3  2006/12/04 12:19:28  hawk
- added vserver patch, lets try release 1

Revision 1.24.2.2  2006/11/13 20:48:00  sparky
- use rpmldfalgs

Revision 1.24.2.1  2006/11/13 20:16:23  sparky
- fixed

Revision 1.24  2006/11/13 20:03:37  sparky
- %{_alt_kernel} support
- use %build_kernel_modules, %install_kernel_modules macros

Revision 1.23  2006/11/13 15:04:12  sparky
- don't use %{without ...}, it may not work after inverting bcond

Revision 1.22  2006/09/28 19:11:55  glen
- unionfs-1.2 is for 2.6.16 kernels

Revision 1.21  2006/09/28 19:11:16  glen
- needs vserver patch (anyone?)

Revision 1.20  2006/09/06 13:48:33  sparky
- mass atack: -j1 for make scripts

Revision 1.19  2006/06/03 15:30:29  glen
- updated to 1.1.4, doesn't build with 2.6.16.19

Revision 1.18  2006/05/04 00:04:52  glen
- new build copied from template-kernel-module.spec
- 2.6.16.11-1 builds with current snap

Revision 1.17  2006/04/12 12:15:40  glen
- add kernel epoch, adapterized

Revision 1.16  2006/03/17 22:03:36  glen
- rel 3

Revision 1.15  2006/03/11 12:25:41  arekm
- rel 2

Revision 1.14  2006/02/05 20:33:37  areq
- new way of modules build
- fix build modules without DEBUG

Revision 1.13  2006/01/28 23:25:20  arekm
- drop Werror

Revision 1.12  2006/01/28 23:17:46  arekm
- up to 1.1.2; fix sparc && ppc

Revision 1.11  2005/09/18 12:24:06  areq
- 1.0.14

Revision 1.10  2005/09/15 18:25:05  sparky
- prepared for kernel >= 2.6.13: link Module.symvers

Revision 1.9  2005/08/31 09:05:13  troll
- spaces to tabs

Revision 1.8  2005/08/31 08:40:47  zboczuch
- correct place for BR line

Revision 1.7  2005/08/31 08:37:30  zboczuch
- BR: libuuid-devel

Revision 1.6  2005/08/10 21:48:41  areq
- disable debug

Revision 1.5  2005/07/28 20:08:41  pluto
- complaint with template-kernel-module.
- build utils in %build.
- kernel modules renamed to kernel-{,smp-}fs-unionfs.
- release 1.

Revision 1.4  2005/07/28 09:25:22  blekot
- up to 1.0.13

Revision 1.3  2005/07/17 20:19:59  qboosh
- pl, kernel/userspace bconds

Revision 1.2  2005/07/17 18:13:42  areq
- fix md5

Revision 1.1  2005/07/17 15:24:59  areq
- raw PLD spec
